%% Resolver ejercicio 1 utilizando newton raphson

clear all
close all
clc


kk = linspace(0.1, 0.5);

plot(kk, Fkappa(kk))
grid on
xlabel('\kappa')
ylabel('F(\kappa)')

% Si, para aplicar newton raphson hay que darse la lata de derivar...
dFKappa = @(k) -exp(-k) * 1./(2*k) - 1./(2*k.^2)*exp(-k) +...
    1./(2*k.^2) -10.2*exp(k);

% b)
kappa = newton_raphson('Fkappa', dFKappa, 0.3, 1e-10, 100);

% 1.3 
% En este caso, lo haremos utilizando una funcion anonima

% T(t) - 36.5
f = @(t) (10.2 + 1/(2*kappa))*exp(-kappa*(t - 20)) + (t + 24)/2 - ...
    1/(2*kappa) - 36.5;

% Derivada de la f definida
df = @(t) (10.2 + 1/(2*kappa))*exp(-kappa*(t - 20)) * (-kappa) + 1/2;

% 1.4
t_star = newton_raphson(f, df, 16, 1e-10, 100);

% Para el resto de los ejercicios se procede de forma similar... No
% calculare la derivada en todos, porque requiere mucho tiempo

%% Resolver ejercicio 1 utilizando biseccion

clear all
close all
clc

kk = linspace(0.1, 0.5);

plot(kk, Fkappa(kk))
grid on
xlabel('\kappa')
ylabel('F(\kappa)')

% b)
kappa = biseccion('Fkappa', 0.1, 0.5, 1e-10);

% 1.3 
% En este caso, lo haremos utilizando una funcion anonima

% T(t) - 36.5
f = @(t) (10.2 + 1/(2*kappa))*exp(-kappa*(t - 20)) + (t + 24)/2 - ...
    1/(2*kappa) - 36.5;

% 1.4
t_star = biseccion(f, 16, 20, 1e-10);
