function [xr, iter, conv] = newton_raphson(f, df, x0, tol, maxit)
% Encuentra una raiz aplicando el metodo de Newton-Raphson.

if feval(df, x0) == 0
    error('Existe un punto singular para la derivada de f')
end

xk = x0 - feval(f, x0)/feval(df, x0);
iter = 1;

% Criterio de convergencia
conv = abs(xk - x0) <= tol;

% Iterar hasta converger
while ~conv && (iter <= maxit)
    x0 = xk;
    
    if feval(df, x0) == 0
        error('Existe un punto singular para la derivada de f')
    end

    xk = x0 - feval(f, x0)/feval(df, x0);
    conv = abs(xk - x0) < tol;
    iter = iter + 1;
end

xr = xk;

end